package hitachi.csmb.checker.gui;

import java.awt.Color;
import java.awt.Component;

import javax.swing.JTable;
import javax.swing.SwingConstants;
import javax.swing.UIManager;
import javax.swing.border.Border;
import javax.swing.table.DefaultTableCellRenderer;

public class ColoredCellRenderer extends DefaultTableCellRenderer {

	public ColoredCellRenderer(int argument){
		this.setHorizontalAlignment(argument);
	}
	
	public ColoredCellRenderer(){
		this.setHorizontalAlignment(SwingConstants.CENTER);
	}
	
	public Component getTableCellRendererComponent(JTable table,
            Object value,
            boolean isSelected,
            boolean hasFocus,
            int row,
            int column){
		Color background = null;
		
				
		if(background!=null){
			super.setBackground(background);
		} else if (isSelected) {
			   super.setForeground(table.getSelectionForeground());
			   super.setBackground(table.getSelectionBackground());
		} else {
			if(row%2!=0){
				super.setBackground(Color.WHITE);
			} else {
				super.setBackground(new Color(0xE5F1FF));
			}
		    super.setForeground(table.getForeground());
		}
			
		setFont(table.getFont());
		
		/*if (hasFocus) {
            Border border = null;
            if (isSelected) {
                border = UIManager.getBorder("Table.focusSelectedCellHighlightBorder");
            }
            if (border == null) {
                border = UIManager.getBorder("Table.focusCellHighlightBorder");
            }
            setBorder(border);
	
		    if (!isSelected && table.isCellEditable(row, column)) {
	                Color col;
	                col = UIManager.getColor("Table.focusCellForeground");
	                if (col != null) {
	                    super.setForeground(col);
	                }
	                col = UIManager.getColor("Table.focusCellBackground");
	                if (col != null) {
	                    super.setBackground(col);
	                }
		    }
		} else {*/
	            setBorder(noFocusBorder);
		//}
		setValue(value); 

		return this;
	}
}
