package hitachi.csmb.checker.gui;

import java.awt.BorderLayout;
import java.awt.GraphicsConfiguration;
import java.awt.HeadlessException;

import javax.swing.JFrame;
import javax.swing.JPanel;

public class MainFrame extends JFrame implements UpdateListener{
	@Override
	public void updatePerformed(UpdateEvent event) {
		rcsPane.updateData(event.getIu());
	}

	private DataPane dataPane;
	private RcsPane rcsPane;
	
	private void initialize(){
		dataPane = new DataPane();
		rcsPane = new RcsPane();
		
		dataPane.addUpdateListener(this);
		
		setLayout(new BorderLayout());
		
		add(dataPane,BorderLayout.CENTER);
		add(rcsPane, BorderLayout.WEST);
	}

	public MainFrame() throws HeadlessException {
		super();
		initialize();
	}

	public MainFrame(GraphicsConfiguration arg0) {
		super(arg0);
		initialize();
	}

	public MainFrame(String arg0, GraphicsConfiguration arg1) {
		super(arg0, arg1);
		initialize();
	}

	public MainFrame(String arg0) throws HeadlessException {
		super(arg0);
		initialize();
	}
	
}
