package hitachi.csmb.checker.gui;

import hitachi.csmb.checker.CsMbChecker;
import hitachi.csmb.checker.work.Iu;
import hitachi.csmb.checker.work.IuOrder;
import info.clearthought.layout.TableLayout;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.LayoutManager;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.EtchedBorder;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

public class RcsPane extends JPanel implements ActionListener,DocumentListener{
	private JLabel idLabel;
	private JLabel ouLabel;
	private JLabel iuLabel;
	private JLabel onOffSet;
	private JLabel modeLabel;
	private JLabel fanLabel;
	private JLabel tempLabel;
	private JLabel louverLabel;
	private JLabel centralLabel;
	
	private JTextField idField;
	private JTextField ouField;
	private JTextField iuField;
	private JTextField onOffField;
	private JTextField modeField;
	private JTextField fanField;
	private JTextField tempField;
	private JTextField louverField;
	private JTextField centralField;
	
	private JButton saveButton;
	private JButton cancelButton;
	
	private boolean updating = false;
	private boolean dataChanged = false;
	
	private void initialize(){
		setPreferredSize(new Dimension(200,200));
		setBackground(Color.white);
		setBorder(new EtchedBorder());
		
		idLabel = new JLabel("Id");
		ouLabel = new JLabel("Ou Address");
		iuLabel = new JLabel("Iu Address");
		onOffSet = new JLabel("On/Off");
		modeLabel = new JLabel("Mode");
		fanLabel = new JLabel("Fan");
		tempLabel = new JLabel("Temp");
		louverLabel = new JLabel("Louver");
		centralLabel = new JLabel("Central");
		
		idField = new JTextField();
		ouField = new JTextField();
		iuField = new JTextField();
		onOffField = new JTextField();
		modeField = new JTextField();
		fanField = new JTextField();
		tempField = new JTextField();
		louverField = new JTextField();
		centralField = new JTextField();
		
		idField.getDocument().addDocumentListener(this);
		ouField.getDocument().addDocumentListener(this);
		iuField.getDocument().addDocumentListener(this);
		onOffField.getDocument().addDocumentListener(this);
		modeField.getDocument().addDocumentListener(this);
		fanField.getDocument().addDocumentListener(this);
		tempField.getDocument().addDocumentListener(this);
		louverField.getDocument().addDocumentListener(this);
		centralField.getDocument().addDocumentListener(this);
		
		saveButton = new JButton("Save");
		cancelButton = new JButton("Cancel");
		
		saveButton.addActionListener(this);
		cancelButton.addActionListener(this);
		
		JPanel buttonPanel = new JPanel(new FlowLayout(FlowLayout.CENTER));
		buttonPanel.add(saveButton);
		buttonPanel.add(cancelButton);
		buttonPanel.setOpaque(false);
		
		double sizes[][] = {{
			5,
			TableLayout.PREFERRED,
			TableLayout.FILL,
			TableLayout.PREFERRED,
			5
		},{
			5,
			TableLayout.PREFERRED,
			TableLayout.PREFERRED,
			TableLayout.PREFERRED,
			TableLayout.PREFERRED,
			TableLayout.PREFERRED,
			TableLayout.PREFERRED,
			TableLayout.PREFERRED,
			TableLayout.PREFERRED,
			TableLayout.PREFERRED,
			TableLayout.PREFERRED,
			5
		}};
		TableLayout tblLayout = new TableLayout(sizes);
		tblLayout.setHGap(5);
		tblLayout.setVGap(5);
		setLayout(tblLayout);
		
		add(idLabel,		"1,1");
		add(ouLabel,		"1,2");
		add(iuLabel,		"1,3");
		add(onOffSet,		"1,4");
		add(modeLabel,		"1,5");
		add(fanLabel,		"1,6");
		add(tempLabel,		"1,7");
		add(louverLabel,	"1,8");
		add(centralLabel,	"1,9");
		
		add(idField,		"2,1");
		add(ouField,		"2,2");
		add(iuField,		"2,3");
		add(onOffField,		"2,4");
		add(modeField,		"2,5");
		add(fanField,		"2,6");
		add(tempField,		"2,7");
		add(louverField,	"2,8");
		add(centralField,	"2,9");
		
		add(buttonPanel,	"1,10,2,10");
		
		idField.setEditable(false);
		iuField.setEditable(false);
		ouField.setEditable(false);
		
		//saveButton.setEnabled(false);
		cancelButton.setEnabled(false);		
	}
	
	public void updateData(Iu iu){
		updating = true;
		if(iu == null){
			/*System.out.println("Clear");
			idField.setText("");
			ouField.setText("");
			iuField.setText("");
			onOffField.setText("");
			modeField.setText("");
			fanField.setText("");
			tempField.setText("");
			louverField.setText("");
			centralField.setText("");*/
		}else{
			if(!idField.getText().equals(""+iu.getId())){
				dataChanged = false;
			}
			idField.setText(""+iu.getId());
			ouField.setText(""+iu.getOuAdd());
			iuField.setText(""+iu.getIuAdd());
			if(!dataChanged) onOffField.setText(""+iu.getOnOffSet());
			if(!dataChanged) modeField.setText(""+iu.getModeSet());
			if(!dataChanged) fanField.setText(""+iu.getFanSet());
			if(!dataChanged) tempField.setText(""+iu.getTempSet());
			if(!dataChanged) louverField.setText(""+iu.getLouverSet());
			if(!dataChanged) centralField.setText(""+iu.getCentralSet());
			
			if(dataChanged){
				cancelButton.setEnabled(true);
			}else{
				cancelButton.setEnabled(false);
			}
		}
		updating = false;
	}

	public RcsPane() {
		super();
		initialize();
	}

	public RcsPane(boolean arg0) {
		super(arg0);
		initialize();
	}

	public RcsPane(LayoutManager arg0, boolean arg1) {
		super(arg0, arg1);
		initialize();
	}

	public RcsPane(LayoutManager arg0) {
		super(arg0);
		initialize();
	}
	
	private void onSave(){
		IuOrder iuOrder = new IuOrder();
		try{
			iuOrder.setId(Integer.parseInt(idField.getText()));
			iuOrder.setOnOffSet(Integer.parseInt(onOffField.getText()));
			iuOrder.setModeSet(Integer.parseInt(modeField.getText()));
			iuOrder.setFanSet(Integer.parseInt(fanField.getText()));
			iuOrder.setTempSet(Integer.parseInt(tempField.getText()));
			iuOrder.setLouverSet(Integer.parseInt(louverField.getText()));
			iuOrder.setCentralSet(Integer.parseInt(centralField.getText()));
			CsMbChecker.worker.sendIuOrder(iuOrder);
			dataChanged = false;
		}catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	private void onCancel(){
		dataChanged = false;
	}

	@Override
	public void actionPerformed(ActionEvent ev) {
		if(ev.getSource().equals(saveButton)){
			onSave();
		}else if(ev.getSource().equals(cancelButton)){
			onCancel();
		}
		
	}

	@Override
	public void changedUpdate(DocumentEvent arg0) {
		if(!updating) {
			dataChanged = true;
			cancelButton.setEnabled(true);
			System.out.println("Changed");		
		}
	}

	@Override
	public void insertUpdate(DocumentEvent arg0) {
		if(!updating) {
			dataChanged = true;
			cancelButton.setEnabled(true);
			System.out.println("Insert");
		}
		
	}

	@Override
	public void removeUpdate(DocumentEvent arg0) {
		if(!updating) {
			dataChanged = true;
			cancelButton.setEnabled(true);
			System.out.println("Remove");
		}
		
	}
	
}
