package hitachi.csmb.checker.work;

import java.util.Vector;

import net.wimpi.modbus.facade.ModbusTCPMaster;
import net.wimpi.modbus.procimg.Register;
import net.wimpi.modbus.procimg.SimpleRegister;

public class Worker extends Thread {
	Data data = new Data();
	Vector<IuOrder> orders;
	private String ip;

	public Data getData() {
		return data;
	}

	public void setData(Data data) {
		this.data = data;
	}
	
	public void sendIuOrder(IuOrder order){
		orders.add(order);
	}
	
	public Worker(String ip){
		this.ip = ip;
	}
	
	ModbusTCPMaster modbusMaster = null;

	@Override
	public void run() {
		
		Register[] registers;
		orders = new Vector<IuOrder>();
		
		try {
			modbusMaster = new ModbusTCPMaster(ip);
			modbusMaster.connect();
		} catch (Exception e){
			e.printStackTrace();
			return;
		}
		
		try{
			for(int i= 0;i<256;i++){
				registers = modbusMaster.readMultipleRegisters(20000+(i*32), 32);
				if(registers!=null && registers.length>0){
					if(registers[0].getValue()>0){
						Iu iu = new Iu();
						iu.setId(i);
						iu.setOuAdd(registers[1].getValue());
						iu.setIuAdd(registers[2].getValue());
						setUnitData(iu,registers);
						data.getUnits().put(iu.getId(), iu);
					}
				}
			}
		}catch (Exception e) {
			e.printStackTrace();
		}
		
		Iu[] ius = (new Vector<Iu>(data.getUnits().values())).toArray(new Iu[0]);
		for(int i=0;i<ius.length;i++){
			System.out.println("Found Id: "+ius[i].getId()+
					" Ou: "+ius[i].getOuAdd()+ " Iu: "+ius[i].getIuAdd());
		}
		
		while(true){
			System.out.println("Reading data");
			for(int i=0;i<ius.length;i++){
				try{
					registers = modbusMaster.readMultipleRegisters(20000+(ius[i].getId()*32), 32);
					if(registers[0].getValue()>0){
						Iu iu = ius[i];
						setUnitData(iu,registers);
						
						/*
						System.out.println("Id: "+iu.getId()+" Ou: "+iu.getOuAdd()+" Iu: "+iu.getIuAdd()+
								" On/Off: "+registers[3].getValue()+
								" Mode: "+registers[4].getValue()+
								" Fan: "+registers[5].getValue()+
								" Tset: "+registers[6].getValue()+
								" Louver: "+(short)registers[7].getValue()+
								" Central: "+registers[8].getValue()
								);*/
					}
				}catch (Exception e) {
					e.printStackTrace();
				}
				try{
					sleep(10);
				}catch (Exception e) {
					e.printStackTrace();
				}
			}
			executeOrders();
			try{
				sleep(500);
			}catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
	
	private void executeOrders(){
		while(orders.size()>0){
			IuOrder order = orders.firstElement();
			sendOrder(order);
			orders.remove(order);
		}
	}
	
	private boolean sendOrder(IuOrder order){
		SimpleRegister registers[] = new SimpleRegister[6];
		//for(int i=0;i<registers.length;i++) registers[i] = new SimpleRegister();
		
		try{
			if(order==null){
				System.out.println("ORDER IS NULL!!!!!");
			}
			registers[0] = new SimpleRegister(order.getOnOffSet());
			registers[1] = new SimpleRegister(order.getModeSet());
			registers[2] = new SimpleRegister(order.getFanSet());
			registers[3] = new SimpleRegister(order.getTempSet());
			registers[4] = new SimpleRegister(order.getLouverSet());
			registers[5] = new SimpleRegister(order.getCentralSet());
						
		
			modbusMaster.writeMultipleRegisters(20000+(order.getId()*32)+3, registers);
		}catch (Exception e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}
	
	private void setUnitData(Iu iu,Register registers[]){
		iu.setOuAdd			((short)registers[1].getValue());
		iu.setIuAdd			((short)registers[2].getValue());
		iu.setOnOffSet		((short)registers[3].getValue());
		iu.setModeSet		((short)registers[4].getValue());
		iu.setFanSet		((short)registers[5].getValue());
		iu.setTempSet		((short)registers[6].getValue());
		iu.setLouverSet		((short)registers[7].getValue());
		iu.setCentralSet	((short)registers[8].getValue());
		iu.setOnOffRead		((short)registers[9].getValue());
		iu.setModeRead		((short)registers[10].getValue());
		iu.setFanRead		((short)registers[11].getValue());
		iu.setTempRead		((short)registers[12].getValue());
		iu.setLouverRead	((short)registers[13].getValue());
		iu.setRcsGroup		((short)registers[14].getValue());
		iu.setTin			((short)registers[15].getValue());
		iu.setTout			((short)registers[16].getValue());
		iu.setTgas			((short)registers[17].getValue());
		iu.setTliquid		((short)registers[18].getValue());
		iu.setAlarm			((short)registers[19].getValue());
		iu.setCompStop		((short)registers[20].getValue());
		iu.setEv			((short)registers[21].getValue());
		iu.setStatus		((short)registers[22].getValue());
		iu.setDefrost		((short)registers[23].getValue());
		iu.setTOutdoor		((short)registers[24].getValue());
		iu.setPowerGroup	((short)registers[25].getValue());
		iu.setTimerDisabled	((short)registers[26].getValue());
		iu.setOptions		((short)registers[27].getValue());
	}

}
